'use strict';

const Promise  = require('bluebird');
const eventBus = require('../index');
eventBus.init({
    bus: {
        url: 'amqp://local.codefresh.io',
        reconnectInterval: 5
    },
    store: {
        host: 'local.codefresh.io',
        database: 'postgres',
        user: 'postgres',
        password: 'postgres'
    },
    microServiceName: 'microservice2'
});

eventBus.on('error', async (err) => {
    console.error(err.toString());
    //await eventBus.quit();
    console.log('quitted');
});


let totalRecieved = 0;
// setInterval(() => {
//     eventBus.publish('myevent', `my message ${totalRecieved}`);
//     totalRecieved++;
//     console.log(`sent message: ${totalRecieved}`);
// }, 1000);
let bool = false;
const subscriber = eventBus.subscribe('myevent', (msg) => {
    return Promise.resolve()
        .then(() => {
            totalRecieved++;
            console.log(`recived message ${totalRecieved}: ${JSON.stringify(msg)}`);
        })
        .then(() => {
            bool = !bool;
            //return Promise.reject(new Error('my error!'));
        })
        .delay(1000);
}, {waitForAck: true, concurrencyLimit: 2, timeout: 2000, ackOnTimeout: true})
    .then((subscriber) => {
        subscriber.on('error', (err) => {
            console.error(err.stack);
        });
    });
